# -*- coding: utf-8 -*-
"""vector.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1c5MqjdkRr1GZ2Ji6ILd3NI2i5ff3Ayip
"""

# Commented out IPython magic to ensure Python compatibility.
import nltk
from nltk import word_tokenize , sent_tokenize
import gensim
from gensim.models.word2vec import Word2Vec
from sklearn.manifold import TSNE
import pandas as pd
from bokeh.io import output_notebook
from bokeh.plotting import show, figure
# %matplotlib inline

nltk.download('punkt')

nltk.download('gutenberg')

from nltk.corpus import gutenberg

gutenberg.fileids()

len(gutenberg.fileids())

sent_tokenize(gutenberg.raw())[1]

word_tokenize(sent_tokenize(gutenberg.raw())[1])

len(gutenberg.words())

input_data=gutenberg.sents()

"""Execute Word2Vec Model"""

model=Word2Vec(sentences=input_data , size=64, sg=1 , window=10 , min_count=5, seed= 123)

len(model.wv.vocab)

model.wv['king']

"""Explore the Word2Vec Model

"""

model.wv.most_similar('java')

model.wv.most_similar('work')

model.wv.most_similar('study')

model.wv.most_similar('day')

model.wv.most_similar('January')

model.wv.doesnt_match(' November August Sunday'.split())

model.wv.similarity('father','mother')

model.wv.similarity('father','queen')

model.wv.similarity('father','king')

model.wv.similarity('study','book')

model.wv.similarity('study','food')

model.wv.similarity('king','queen')

model.wv.most_similar(positive=['son','woman'],negative=['man'])

X=model.wv[model.wv.vocab]

tsne=TSNE(n_components=2 , n_iter= 250)

x_2d=tsne.fit_transform(X)

wv_df=pd.DataFrame(x_2d,columns=['x','y'])
wv_df['token']=model.wv.vocab.keys()

wv_df.head()

wv_df.plot.scatter('x','y' , figsize=(12,12), marker = '.' , s=10 , alpha= 0.2)